controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;
use app\models\Ciclista;
use app\models\puerto;
use app\models\etapa;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    
    //DAO
    public function actionConsulta1(){
        
        $numero = Yii::$app->db
                ->createCommand('select count(dorsal) as numero_ciclistas from ciclista')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT count(dorsal) as numero_ciclistas FROM ciclista',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['numero_ciclistas'],
        "titulo"=>"consulta 1 con DAO",
        "enunciado"=>" Número de ciclistas que hay",
        "sql"=>"SELECT count(dorsal) as numero_ciclistas FROM ciclista",
    ]);
    }
    
    public function actionConsulta2(){
        
        $numero = Yii::$app->db
                ->createCommand('select count(dorsal) as numero_dciclistas from ciclista where nomequipo="Banesto"')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT count(dorsal) as numero_ciclistas FROM ciclista WHERE nomequipo="Banesto"',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['numero_ciclistas'],
        "titulo"=>"consulta 2 con DAO",
        "enunciado"=>" Número de ciclistas que hay del equipo Banesto",
        "sql"=>'SELECT count(dorsal) as numero_ciclistas FROM ciclista WHERE nomequipo="Banesto"',
    ]);
    }
    
    public function actionConsulta3(){
        
        $numero = Yii::$app->db
                ->createCommand('select AVG(edad) as media_edad from ciclista')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT AVG(edad) as media_edad FROM ciclista',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['media_edad'],
        "titulo"=>"consulta 3 con DAO",
        "enunciado"=>"Edad media de los ciclistas",
        "sql"=>'SELECT AVG(edad) as media_edad FROM ciclista',
    ]);
    }
    
    public function actionConsulta4(){
        
        $numero = Yii::$app->db
                ->createCommand('select AVG(edad) as media_edad from ciclista where nomequipo="Banesto"')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT AVG(edad) as media_edad FROM ciclista WHERE nomequipo="Banesto"',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['media_edad'],
        "titulo"=>"consulta 4 con DAO",
        "enunciado"=>"La edad media de los del equipo Banesto",
        "sql"=>'SSELECT AVG(edad) as media_edad FROM ciclista WHERE nomequipo="Banesto"',
    ]);
    }
    
    public function actionConsulta5(){
        
        $numero = Yii::$app->db
                ->createCommand('select AVG(edad) as media_edad, nomequipo from ciclista group by nomequipo')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT AVG(edad) as media_edad, nomequipo FROM ciclista GROUP BY nomequipo',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['media_edad','nomequipo'],
        "titulo"=>"consulta 5 con DAO",
        "enunciado"=>"La edad media de los ciclistas por cada equipo",
        "sql"=>'SELECT AVG(edad) as media_edad, nomequipo FROM ciclista GROUP BY nomequipo',
    ]);
    }
    
    public function actionConsulta6(){
        
        $numero = Yii::$app->db
                ->createCommand('select count(dorsal) as numero_ciclistas, nomequipo from ciclista group by nomequipo')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT count(dorsal) as numero_ciclistas, nomequipo FROM ciclista GROUP BY nomequipo',
            
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['numero_ciclistas','nomequipo'],
        "titulo"=>"consulta 6 con DAO",
        "enunciado"=>"El número de ciclistas por equipo",
        "sql"=>'SELECT count(dorsal) as numero_ciclistas, nomequipo FROM ciclista GROUP BY nomequipo',
    ]);
    }
    
    public function actionConsulta7(){
        
        $numero = Yii::$app->db
                ->createCommand('select count(nompuerto) as numero_puertos from puerto')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT count(nompuerto) as numero_puertos FROM puerto',
            
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['numero_puertos'],
        "titulo"=>"consulta 7 con DAO",
        "enunciado"=>"El número total de puertos",
        "sql"=>'SELECT count(nompuerto) as numero_puertos FROM puerto',
    ]);
    }
    
    public function actionConsulta8(){
        
        $numero = Yii::$app->db
                ->createCommand('select count(nompuerto) as numero_puertos from puerto where altura>1500')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT count(nompuerto) as numero_puertos FROM puerto WHERE altura>1500',
            'totalCount'=>$numero,
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
       "resultados"=>$dataProvider,
        "campos"=>['numero_puertos'],
        "titulo"=>"consulta 8 con DAO",
        "enunciado"=>"El número total de puertos mayores de 1500",
        "sql"=>'SELECT count(nompuerto) as numero_puertos FROM puerto WHERE altura>1500',
    ]);
    }
    
    public function actionConsulta9(){
        
        $numero = Yii::$app->db
                ->createCommand('select nomequipo, COUNT(dorsal) as numero_ciclistas from ciclista group by nomequipo having COUNT(dorsal)>4 order by COUNT(dorsal)')
                ->queryScalar();
        
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT nomequipo, COUNT(dorsal) as numero_ciclistas FROM ciclista GROUP BY nomequipo HAVING COUNT(dorsal)>4 ORDER BY COUNT(dorsal)',
            
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de Selección 2</h1>
        
    </div>

    <div class="body-content">

        <div class="">
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h2>Consulta 1</h2>

                <p>Número de ciclistas que hay</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala1'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta1'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
                
            </div>
            <div  class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h2>Consulta 2</h2>

                <p>Número de ciclistas que hay del equipo Banesto</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala2'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta2'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
                
            </div>
            <div  class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h2>Consulta 3</h2>
                
                <p>Edad media de los ciclistas</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala3'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta3'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
                
            </div>
        </div>
        
        <div class="">
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 4</h2>

                <p>La edad media de los del equipo Banesto</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala4'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta4'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 5</h2>

                <p>La edad media de los ciclistas por cada equipo</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala5'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta5'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 6</h2>
                
                <p>El número de ciclistas por equipo</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala6'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta6'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
        </div>
        
        <div class="">
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 7</h2>

                <p>El número total de puertos</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala7'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta7'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 8</h2>

                <p>El número total de puertos mayores de 1500</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala8'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta8'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 9</h2>
                
                <p>Listar el nombre de los equipos que tengan más de<br>
                    4 ciclistas</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala9'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta9'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
        </div>
        
        <div class="">
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 10</h2>

                <p> Listar el nombre de los equipos que tengan más de<br>
                    4 ciclistas cuya edad esté entre 28 y 32</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala10'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta10'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 11</h2>

                <p>Indícame el número de etapas que ha ganado cada<br>
                    uno de los ciclistas</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala11'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta11'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 cod-md-4">
                <div class="thumbnail">
                    <div class="caption">
                <h2>Consulta 12</h2>

                <p>Indícame el dorsal de los ciclistas que hayan<br>
                    ganado más de una etapa</p>
                <p>
                    <?= Html::a('Active Record', ['site/consultala12'], ['class' => 'btn btn-primary'])?>
                    <?= Html::a('DAO', ['site/consulta12'], ['class' => 'btn btn-default'])?>
                </p>
                    </div>
                </div>
            </div>
        </div>

    </div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"col-lg-offset-1 col-lg-3\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="col-lg-offset-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

<div class="junbotron">
        <h2><?=$titulo?></h2>
        
        <p class="lead"><?= $enunciado ?></p>
        <div class="well">
            <?= $sql ?>
        </div>
    </div>

    <?=GridView::widget([
        'dataProvider' => $resultados,
        'columns'=>$campos
            
    ]); ?>